        PAGE    60,132
        TITLE   EMMSTAT - REPORT STATUSE OF EXPANDED MEMORY MANAGER

;    EMMSTAT - PROGRAM TO REPORT VARIOUS FACTS ABOUT THE CURRENT
;              STATUS OF THE EXPANDED MEMORY MANAGER.  THIS PROGRAM
;              MAKES USE OF A NUMBER OF EMM CALLS TO LOCATE, AND
;              VERIFY THE STATUS OF EMS AND EEMS VERSIONS OF EMM.

STACK       SEGMENT WORD STACK 'STACK'
            DB     100H DUP (?)
STACK       ENDS

DATA        SEGMENT WORD PUBLIC 'DATA'
EMMHANDLE       DW      ?                 ; HANDLE FROM OPENING EMM
EMMNAME         DB      'EMMXXXX0',0            ; NAME OF EMM
PHYS_WINDOW     DB      64 DUP(?)         ; PHYSICAL WINDOW ARRAY
HDRMSG          DB      0AH, 0DH, 'EMMSTAT - Copyright, 1987  '
                DB      'John A. Lefor', 0AH, 0DH,'$'
NOHANDLEMSG     DB      0AH, 0DH, 'Unable to test for EMM - '
                DB      'No file handles available.$'
NOEMMMSG        DB      0AH, 0DH, 'Unable to locate EMM - '
                DB      'Expanded Memory not present in system.$'
NOTREADY        DB      0AH, 0DH, 'EMM present but not Ready, '
                DB      'Reboot system.$'
EMSEMM          DB      0AH, 0DH, 'EMS Expanded Memory Manager '
                DB      'present in system.$'
EEMSEMM         DB      0AH, 0DH, 'EEMS Expanded Memory Manager '
                DB      'present in system.$'
PAGEMSG         DB      0AH, 0DH, 'Total Memory Pages in system: $'
AVAILPAGES      DB      0AH, 0DH, 'Total Memory Pages available: $'
VERSIONMSG      DB      0AH, 0AH, 0DH, 'EMM Version: $'
PFMSG           DB      0AH, 0DH, 'Page Frame Segment: '
PFADDR          DB      'XXXX$'
HANDLEMSG       DB      0AH, 0DH, 'Handles in use: $'
ERRMSG          DB      0AH, 0AH, 0DH, 'EMM reports error code: '
ERRCODE         DB      'XX'
ERREND          DB      '.$'
DATA        ENDS

CODE        SEGMENT BYTE PUBLIC 'CODE'
            ASSUME CS:CODE,DS:DATA

DISPLAY      EQU     09H
DOS          EQU     21H
DISPCHAR     EQU     02H
DOSOPEN      EQU     3DH
HANDLERR     EQU     4                   ; ERROR RETURN - NO HANDLES
DOSCLOSE     EQU     3EH
READ         EQU     00H                 ; ACCESS MODE IS READ ACCESS
COMPAT       EQU     00H                 ; FILE COMPATIBILITY MODE
IOCTL        EQU     44H
GETDEVINFO   EQU     00H                 ; REQUEST DEVICE INFORMATION
GETOUTSTAT   EQU     07H                 ; REQUEST OUTPUT STATUS
DEVFLAG      EQU     80H                 ; DEVICE FLAG IN DEVICE INFO
TERMINATE    EQU     4CH                 ; TERMINATE PROCESS
WINDOW_ARRAY EQU     60H                 ; GET STD PHYS WINDOW ARRAY

EMM          EQU     67H
EMMSTATUS    EQU     40H
EMMVERSION   EQU     46H
EMMPAGECOUNT EQU     42H
EMMPAGEFRAME EQU     41H
EMMHANDLES   EQU     4BH

;       ESTABLISH IF AN EMM EXISTS IN THE SYSTEM USING
;       THE OPEN HANDLE METHOD

START:
           MOV     AX, DATA
           MOV     DS, AX                  ; LOAD DATA SEGMENT
           MOV     DX, OFFSET HDRMSG
           MOV     AH, DISPLAY
           INT     DOS
           MOV     DX, OFFSET EMMNAME      ; -> NAME OF EMM
           MOV     AH, DOSOPEN             ; REQUEST AN OPEN
           MOV     AL, READ+COMPAT
           INT     DOS                     ; CALL DOS
           JNC     TESTFILE                ; IF OK, TEST FOR FILE

;       OPEN FAILED, EMM NOT PRESENT OR NO HANDLES AVAILABLE

           CMP     AX, HANDLERR            ; WAS IT HANDLE ERROR?
           JNE     NOEMMERR
           MOV     DX, OFFSET NOHANDLEMSG
           JMP     NOHANDERR
NOEMMERR:  MOV     DX, OFFSET NOEMMMSG     ; POINT TO MESSAGE
NOHANDERR: MOV     AH, DISPLAY             ; REQUEST MSG DISPLAY
           INT     DOS                     ; CALL DOS
           JMP     END

;       TEST FOR FILE OR DEVICE DRIVER

TESTFILE:
           MOV     EMMHANDLE, AX       ; SAVE HANDLE FOR CLOSE LATER
           MOV     BX, AX                  ; PLACE HANDLE IN BX
           MOV     AH, IOCTL               ; IOCTL REQUEST
           MOV     AL, GETDEVINFO
           MOV     CX, 0                   ; NO BYTES TO MOVE
           INT     DOS                     ; CALL DOS
           JNC     CHKBIT7                 ; IF OK, NEED TO CHECK

;       IOCTL FAILED, PRESUME EMM NOT PRESENT

           MOV     DX, OFFSET NOEMMMSG     ; POINT TO MESSAGE
           MOV     AH, DISPLAY             ; REQUEST DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE
           JMP     END

CHKBIT7:
           AND     DX, DEVFLAG             ; TEST FOR DEVICE FLAG
           JNZ     TESTSTATUS              ; IF PRESENT TEST STATUS

;       OPEN FOUND A FILE, EMM NOT PRESENT

           MOV     DX, OFFSET NOEMMMSG     ; POINT TO MESSAGE
           MOV     AH, DISPLAY             ; REQUEST DISPLAY
           INT     DOS                     ; CALL DOS
           JMP     END

;       NOW TEST DEVICE DRIVER STATUS

TESTSTATUS:
           MOV     AH, IOCTL               ; IOCTL CALL
           MOV     AL, GETOUTSTAT          ; REQUEST OUTPUT STATUS
           MOV     CX, 0                   ; NOTHING TO MOVE
           INT     DOS                     ; CALL DOS
           JNC     CHKSTAT

;       IOCTL FAILED, PRESUME EMM NOT PRESENT

           MOV     DX, OFFSET NOEMMMSG     ; POINT TO MESSAGE
           MOV     AH, DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE
           JMP     END

;       TEST RETURN FROM IOCTL FOR READY STATUS

CHKSTAT:
           CMP     AL, 0FFH                ; STATUS OK?
           JE      EMMPRESENT

;       STATUS NOT AS EXPECTED, EMM NOT READY

           MOV     DX, OFFSET NOTREADY     ; POINT TO MESSAGE
           MOV     AH, DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE
           JMP     END

;       EMM IS PRESENT, NOW DETERMINE IF IT IS EMS OR EEMS
;       DO THIS BY ISSUING AN EEMS CALL (FUNCTION CODE 60H)
;       AND TEST THE RETURN CODE.  IF INVALID RETURN CODE
;       MUST BE EMS, OTHERWISE IS EEMS.

EMMPRESENT:
           MOV     AH, WINDOW_ARRAY      ; GET STD PHYS WINDOW ARRAY
           PUSH    DS                      ; SAVE DATA SEGMENT ADDR
           POP     ES                      ; PLACE IN ES FOR CALL
           MOV     DI, OFFSET PHYS_WINDOW  ; WINDOW ARRAY HERE
           INT     EMM                     ; CALL EMM
           OR      AH,AH                   ; TEST RETURN CODE
           JZ      FOUNDEEMS               ; IF ZERO WE HAVE EEMS

;       BAD RETURN FROM EMM, WE MUST HAVE AN EMS SYSTEM

           MOV     DX, OFFSET EMSEMM       ; SET MESSAGE
           MOV     AH, DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE
           JMP     GETVERSION

FOUNDEEMS:
           MOV     DX, OFFSET EEMSEMM      ; SET MESSAGE
           MOV     AH, DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE

;       GET THE VERSION LEVEL OF THE EMM

GETVERSION:
           MOV     AH, EMMVERSION          ; REQUEST VERSION #
           INT     EMM                     ; CALL EMM
           OR      AH,AH                   ; TEST RETURN CODE
           JZ      SHOWVERSION
           CALL    EMMERROR
           JMP     END

SHOWVERSION:
           PUSH    AX                      ; SAVE VERSION
           MOV     DX, OFFSET VERSIONMSG
           MOV     AH, DISPLAY
           INT     DOS
           POP     AX
           PUSH    AX                      ; SAVE FOR NEXT DIGIT
           AND     AX, 00F0H               ; ISOLATE MAJOR VER #
           MOV     CL, 4                   ; SHIFT TO LOW BITS
           SHR     AX, CL
           CALL    PRTDEC                  ; PRINT MAJOR VER #
           MOV     AH, DISPCHAR
           MOV     DL,'.'
           INT     DOS                     ; PRINT A PERIOD
           POP     AX                      ; GET EMM VERSION
           AND     AX, 000FH               ; ISOLATE MINOR VERSION
           CALL    PRTDEC                  ; PRINT MINOR VERSION

;       GET THE ADDRESS OF THE PAGE FRAMES FOR DISPLAY

           MOV     AH, EMMPAGEFRAME        ; REQUEST PF ADDRESS
           INT     EMM                     ; CALL EMM
           OR      AH, AH                  ; TEST RETURN CODE
           JZ      SHOWPF_ADDR
           CALL    EMMERROR
           JMP     END

SHOWPF_ADDR:
           MOV     DI, OFFSET PFADDR
           MOV     AX, BX                  ; PLACE ADDRESS IN AX
           CALL    PRTHEX                  ; DISPLAY ADDRESS
           MOV     DX, OFFSET PFMSG        ; DISPLAY MESSAGE
           MOV     AH, DISPLAY
           INT     DOS

GETSIZE:

;       THERE IS AN EMS OR EEMS MANAGER PRESENT TEST FOR AMOUNT
;       OF EXPANDED MEMORY ON THE MEMORY BOARD(S).

           MOV     AH, EMMPAGECOUNT
           INT     EMM                     ; CALL THE EMM
           OR      AH, AH                  ; TEST FOR ERRORS
           JZ      SHOWPAGE
           CALL    EMMERROR
           JMP     END

SHOWPAGE:
           PUSH    DX                      ; SAVE PAGE INFO
           MOV     DX, OFFSET PAGEMSG      ; DISPLAY PAGES
           MOV     AH, DISPLAY
           INT     DOS                     ; DISPLAY MESSAGE
           POP     AX                      ; RECOVER TOTAL PAGES
           CALL    PRTDEC                  ; DISPLAY # OF PAGES
           MOV     DX, OFFSET AVAILPAGES
           MOV     AH, DISPLAY
           INT     DOS
           MOV     AX, BX                  ; DISPLAY PAGES AVAILABLE
           CALL    PRTDEC

;       DISPLAY NUMBER OF HANDLES IN USE

           MOV     AH, EMMHANDLES          ; REQUEST # OF HANDLES
           INT     EMM                     ; CALL EMM
           OR      AH, AH                  ; TEST RETURN CODE
           JZ      SHOWHANDLES
           CALL    EMMERROR
           JMP     END

SHOWHANDLES:
           MOV     DX, OFFSET HANDLEMSG    ; SET MESSAGE
           MOV     AH, DISPLAY
           INT     DOS                     ; PRINT MESSAGE
           MOV     AX, BX                  ; HANDLE COUNT IN AX
           CALL    PRTDEC                  ; PRINT THE MESSAGE

END:
;       BEFORE TERMINATING, CLOSE THE EMM HANDLE SET DURING OPEN

           MOV     BX, EMMHANDLE           ; SET THE HANDLE
           MOV     AH, DOSCLOSE
           INT     DOS
           MOV     AL, 0                   ; ZERO RETURN CODE
           MOV     AH, TERMINATE           ; END PROGRAM
           INT     DOS
        PAGE
EMMERROR   PROC    NEAR

;       ROUTINE TO DISPLAY EMM ERROR MESSAGES
;       PRESUMES AH CONTAINS THE ERROR CODE

           MOV     DI, OFFSET ERRCODE
           CALL    PRTHEX                  ; FORMAT THE HEX
           MOV     AX,'$.'
           MOV     WORD PTR ERREND, AX     ; TERMINATE MESSAGE
           MOV     DX, OFFSET ERRMSG
           MOV     AH, DISPLAY
           INT     DOS
           RET
EMMERROR   ENDP

INCLUDE PRTPROC.ASM           ; INSERT CONVERSION ROUTINES

CODE       ENDS
           END    START
